package org.processmining.streamilpminer.plugins;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.eventstream.core.interfaces.XSEventStream;
import org.processmining.eventstream.readers.acceptingpetrinet.XSEventStreamToAcceptingPetriNetReader;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.stream.core.enums.CommunicationType;
import org.processmining.streamabstractrepresentation.plugins.AbstractUncoupledStreamMinerDefaultDialogsPlugin;
import org.processmining.streamilpminer.algorithms.UncoupledStreamILPMinerImpl;
import org.processmining.streamilpminer.parameters.UncoupledStreamILPMinerParameters;

@Plugin(name = "Discover Accepting Petri Net(s) (ILP Miner)", parameterLabels = { "Event Stream" }, returnLabels = {
		"ILP Miner (Event Stream)" }, returnTypes = { XSEventStreamToAcceptingPetriNetReader.class })
public class StreamILPMinerPlugin extends
		AbstractUncoupledStreamMinerDefaultDialogsPlugin<XSEventStreamToAcceptingPetriNetReader, UncoupledStreamILPMinerParameters> {

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = StreamILPMinerPluginInfo.AUTHOR, email = StreamILPMinerPluginInfo.EMAIL)
	@PluginVariant(requiredParameterLabels = { 0 })
	@Override
	public XSEventStreamToAcceptingPetriNetReader apply(UIPluginContext context, XSEventStream stream) {
		return super.apply(context, stream);
	}

	protected UncoupledStreamILPMinerParameters getFreshParameters(PluginContext context) {
		return new UncoupledStreamILPMinerParameters();
	}

	protected XSEventStreamToAcceptingPetriNetReader constructReader(PluginContext context, CommunicationType comm,
			UncoupledStreamILPMinerParameters parameters) {
		return new UncoupledStreamILPMinerImpl(context, parameters);
	}

}
